;; newLispTurtle.lsp - graphics demo for newLISP-pdScript
;;
;; to run: (run)
;;
;; Modified from Turtle.lsp from old newLISP-tk distribution
;; Ported to pdScript
;; Hans-Peter Wickern
;; 25.08.2011 07:43:39

(context 'Turtle)

(set-locale "C")

(set 'color "blue")

(set 'direction -425.6857918)

(define (dragon sign level)
  (if (= 0 level)
   (turtle-forward 4)
   (begin
    (dec level) 					;Remove quote for newLISP 10 (9.9.92)
    (turtle-right (sign 45))
    (dragon - level)
    (turtle-left (sign 90))
    (dragon + level)
    (turtle-right (sign 45)))))

(define (dragon-curve n clr)
  (set 'color clr)
  (dragon + n))

(define (draw )
  (MAIN:pdImageDrawLines MAIN:pdScriptInstanceAddr "pdImageDrawLines" (string(join(map tround points)"|")) "|" (string color) "" "")
  (MAIN:pdImageRefresh MAIN:pdScriptInstanceAddr "pdImageRefresh")
  (set 'points (list newX newY)))

(define (tround   rnumb)
	(if (>=(sub rnumb (floor rnumb))0.5)
		(string(ceil rnumb))
		(string(floor rnumb))
	))

(define (draw-rect n)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n))

(define (draw-squirl n)
  (dotimes (x (/ n 3))
   (turtle 'forward n)
   (turtle 'right 90)
   (set 'n (- n 2)))
  (turtle-go-to 0 0))

(set 'lastX 120)

(set 'lastY 200)

(set 'newX 120)

(set 'newY 200)

(define (rose clr)
  (set 'color clr)
  (dotimes (x 90)
   (draw-rect 60)
   (turtle-right 2)))

(define (run )
  (MAIN:pdImageTextOut MAIN:pdScriptInstanceAddr "pdImageTextOut" "Dragon Fractal" "380" "70" "Times" "12" "clWhite" "clNavy")
  (MAIN:pdImageTextOut MAIN:pdScriptInstanceAddr "pdImageTextOut" "Turtle Graphics" "100" "350" "Times" "16" "clWhite" "clNavy")
  (MAIN:pdImageRefresh MAIN:pdScriptInstanceAddr "pdImageRefresh")
  (turtle-start 300 50)
  (dragon-curve 12 "clRed")
  (draw)
  (turtle-start 120 200)
  (rose "clBlue")
  "Ready"
  )

(define (turtle-center )
  (set	'lastX 150
	'lastY 60
	'newX 150
	'newY 60
	'direction 1.570796327))

(define (turtle-forward d)
  (set	'newX (add lastX (mul (cos direction) d))
	'newY (add lastY (mul (sin direction) d)))
  (push newX points -1)
  (push newY points -1)
  (if (= (length points) 100)
   (draw))
  (set	'lastX newX
	'lastY newY))

(define (turtle-go-to x y)
  (set	'lastX x
	'lastY y))

(define (turtle-left d)
  (set 'direction (add direction (mul d 0.017453292))))

(define (turtle-right d)
  (set 'direction (sub direction (mul d 0.017453292))))

(define (turtle-start x y)
  (set	'lastX x
	'lastY y
	'newX x
	'newY y
	'points (list x y)
	'direction 1.570796327))

(set 'x 0)

(context 'MAIN)