;Test-Lsp for calling a pdScript-Dialog from newlisp.EXE
;written by Hans-Peter Wickern 21.09.2011

(import "user32.dll" "MessageBoxA")
(import "newlisp.dll" "newlispEvalStr")
(import "newlisp.dll" "newlispCallback")
(import "pdScriptE.dll" "pdScriptInlineExLibA")
(import "pdScriptE.dll" "pdsFreeMem")
;passing some testvalues to a newlisp-dll instance working as shared memory to pdScript-Dialog
(newlispEvalStr "(setq DllTest1 10 DllTest2 20 DllTest3 30)")
(setq ExeTest1 40 ExeTest2 50 ExeTest3 60)
(define (mycallback stext)
	(MessageBoxA 0 (string "Inside MyCallBack: "(get-string stext)) "newLISP EXE" 0)
	(setq globalresult(eval-string (get-string stext)))
	(MessageBoxA 0 (string "Done MyCallBack: " globalresult) "newLISP EXE" 0)
)
(setq callbackadr(callback 0 'mycallback))
;(MessageBoxA 0 (string "This is callbackadr: " callbackadr) "newLISP EXE" 0)

;;Define and register the callback-function in the DLL
;(setq newlispstr (string "(setq nlmaincallback print)(cpymem(pack \"ld\" 265)(first(dump nlmaincallback))4)(cpymem(pack \"ld\" "callbackadr")(+(first(dump nlmaincallback))12)4)(cpymem(pack \"ld\" "nlmaincallback")(+(first(dump nlmaincallback))8)4)"))
;;(MessageBoxA 0 (string "This is newlispstr: " newlispstr) "newLISP EXE" 0)
;(newlispEvalStr newlispstr)

; This new command from newlisp 10.3.3 allows shorter callbackregister
(newlispCallback "nlmaincallback" (callback 0 'mycallback)"")

;(newlispEvalStr "(import \"user32.dll\" \"MessageBoxA\")")

;(MessageBoxA 0 (string(symbols)) "newLISP EXE" 0)

;(MessageBoxA 0 (newlispEvalStr "(string(symbols))") "newLISP EXE" 0)

(newlispEvalStr "(nlmaincallback \"(setq ExeTest4 (+ ExeTest1 ExeTest2))\")")
(MessageBoxA 0 (string "ExeTest4: "ExeTest4) "newLISP EXE" 0)

;Set up a pdScript dialog source DFM
(setq DfmText [text]
object PSForm: TPSForm
  Left = 279
  Top = 90
  BorderIcons = [biSystemMenu]
  BorderStyle = bsSingle
  Caption = 'newLispExeForm'
  ClientHeight = 114
  ClientWidth = 264
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'Tahoma'
  Font.Style = []
  OldCreateOrder = False
  Position = poDesigned
  PixelsPerInch = 96
  TextHeight = 13
  object Button1: TButton
    Left = 188
    Top = 88
    Width = 73
    Height = 21
    Caption = 'OK'
    TabOrder = 0
  end
  object Edit1: TEdit
    Left = 4
    Top = 4
    Width = 257
    Height = 21
    TabOrder = 1
    Text = 'Edit1'
  end
  object Edit2: TEdit
    Left = 4
    Top = 32
    Width = 257
    Height = 21
    TabOrder = 2
    Text = 'Edit2'
  end
  object Edit3: TEdit
    Left = 4
    Top = 60
    Width = 257
    Height = 21
    TabOrder = 3
    Text = 'Edit3'
  end
  object Button2: TButton
    Left = 4
    Top = 88
    Width = 73
    Height = 21
    Caption = 'call DLL'
    TabOrder = 4
  end
  object Button3: TButton
    Left = 80
    Top = 88
    Width = 73
    Height = 21
    Caption = 'callback'
    TabOrder = 5
  end
end
[/text]
)
;Set up a pdScript pascal source
(setq DpasText [text]
program Script1;

function newLispEvalStr(paramstr: PChar): PChar; external 'newlispEvalStr@newlisp.dll stdcall';

procedure Button1_OnClick(Sender: TObject);
var  nlstr :string;
begin
 writeln('Dialog Result: '+Edit1.Text+' '+Edit2.Text+' '+Edit3.Text);
 nlstr := '(setq Edit1 "'+Edit1.Text+'" Edit2 "'+Edit2.Text+'" Edit3 "'+Edit3.Text+'")';
 showmessage (nlstr);
 newLispEvalStr(nlstr);
 Self.close;
end;

procedure Button2_OnClick(Sender: TObject);
var  r :string;
begin
 r  :=  newLispEvalStr('DllTest1');
 r := Copy(r,1,length(r)-1);
 Edit1.Text :=  r;
 r  :=  newLispEvalStr('DllTest2');
 r := Copy(r,1,length(r)-1);
 Edit2.Text :=  r;
 r  :=  newLispEvalStr('DllTest3');
 r := Copy(r,1,length(r)-1);
 Edit3.Text :=  r;
end;

procedure Button3_OnClick(Sender: TObject);
begin
 newLispEvalStr('(nlmaincallback "(setq ExeTest5 (+ ExeTest2 ExeTest3))")');
end;

procedure AssignEvents;
begin
  Button1.OnClick := @Button1_OnClick;
  Button2.OnClick := @Button2_OnClick;
  Button3.OnClick := @Button3_OnClick;
end;

begin
  AssignEvents;
end.
[/text]
)
;Setup other pdScript params
(setq DpasParam (string "/PDST"))
;(setq DpasParam "")
;Lutz advise from the forum
(setq pptr (dup "\000" 4)) ; allocate space for a 32-bit pointer
(setq DpasLibPath "")
;call pdScript Inline
(setq scriptresult(pdScriptInlineExLibA DpasText DfmText DpasParam 0 pptr DpasLibPath))
;Lutz advise from the forum
 (setq ptr(first(unpack "lu" pptr)))
; (MessageBoxA 0 (string ptr) "pdScript Test" 0)
 (if (> ptr 0)
  (begin
   (setq OutPutBuffer (get-string ptr)) ; -> the content memory
   (pdsFreeMem ptr)                        ; free the memory
  )
  (setq OutPutBuffer "No pdScript output") ;
 )
;scriptresult is set to 0 when successfull
(MessageBoxA 0 (string "This is pdScript return-value: " scriptresult) "pdScript Test" 0)
(MessageBoxA 0 (string "This is pdScript output buffer: " OutPutBuffer) "pdScript Test" 0)
;Getting back values from the newlisp DLL instance setted in dialog exit
(setq edit1 (replace "\n"(get-string(newlispEvalStr "Edit1"))""))
(setq edit2 (replace "\n"(get-string(newlispEvalStr "Edit2"))""))
(setq edit3 (replace "\n"(get-string(newlispEvalStr "Edit3"))""))
(MessageBoxA 0 (string "This is back from DLL: " edit1 " " edit2 " " edit3) "pdScript Test" 0)
(MessageBoxA 0 (string "This is from EXE: ExeTest1: " ExeTest1 " ExeTest2: " ExeTest2 " ExeTest3: " ExeTest3 " ExeTest4: " ExeTest4 " ExeTest5: " ExeTest5) "pdScript Test" 0)

;(MessageBoxA 0 (string "pdScript test end") "pdScript Test" 0)
(exit)